Com.Frog.Utils.require(
    '//package/widgets/6EF51CBD2001B2A4D3617F462CF2F603234CCB2CF2CA01D1/assets/styles/main.css',
    '//package/widgets/6EF51CBD2001B2A4D3617F462CF2F603234CCB2CF2CA01D1/assets/views/main.ejs',
    '//package/widgets/6EF51CBD2001B2A4D3617F462CF2F603234CCB2CF2CA01D1/widget.ejs'
).then(function() {
    Com.Frog.Controllers.Widget.extend('Widget.DateSelector', {
    }, {
        prefs: {
            associations: {
                'type': 'associations',
                'label': 'Widget Collections',
                'defaultValue': JSON.stringify({
                    'associations': [],
                    'publisher': true,
                    'subscriber': false
                })
            },
            date: {
                type: 'date',
                label: 'Date to show reports from',
                defaultValue: ''
            }
        },

        packageID: '6EF51CBD2001B2A4D3617F462CF2F603234CCB2CF2CA01D1',

        init: function() {},
        
        broadcastInterval: function() {
            if (this.prefs.date.value !== '') {
                var currentDate = moment().valueOf();
                var startDate = moment(this.prefs.date.value, 'DD/MM/YYYY').valueOf();
                var controller = new Frog.Widget.Controller(this.element, {}, {prefs: this.prefs});
                controller.broadcast(
                    'selectedInterval',
                    new Broadcast.Models.Interval({
                        startTime: startDate,
                        endTime: currentDate
                    })
                );
            }
        },
        
        'page.loaded': function(el, ev) {
            if (this.options.userIsAuthenticated) {
                this.broadcastInterval();
            }
        },

        'widget.live': function(el, ev, data) {
            this.element.html(
                this.view('main.ejs')
            );
            this.broadcastInterval();
        },

        'widget.edit': function(el, ev, data) {
            this.element.html(
                this.view('./widget.ejs')
            );
        },

        'widget.updated': function(el, ev, data) {}
    });
});
